<?
# Module: Auth
# unique-auth.inc - Unique user auth module
# Derechos Reservados (c) 2002 Sandino Araico Snchez
# Derechos Reservados (c) 2002 Presidencia de la Repblica
# Copyright (c) 2002 Sandino Araico Snchez All rights reserved

/*
 * --COMIENZA LICENCIA EN ESPAOL MEXICANO-------------------------------------
 * Por ste medio se otroga permiso, libre de cargo, a cualquier persona que
 * obtenga una copia de este software y archivos de documentacin asociados
 * (el "Software"), a utilizar el Software sin restriccin, incluyendo sin 
 * limitacin los derechos de usar, copiar, modificar, unir, publicar, 
 * distribuir y/o vender copias de el Software, y permitir lo mismo a personas 
 * a quienes les sea entregado el software, siempre y cuando los avisos de 
 * Derechos reservados y Copyright que aparecen arriba y ste permiso (en 
 * espaol y en ingls) aparezcan en todas las copias de el Software y que 
 * tanto los avisos de Derechos reservados y Copyright que aparecen arriba como
 * ste permiso (en espaol y en ingls) aparezcan en la documentacin de
 * soporte.
 *
 * ESTE SOFTWARE SE PROVEE "TAL CUAL", SIN NINGUNA GARANTA DE NINGN TIPO,
 * EXPRESA O IMPLCITA, INCLUYENDO PERO NO LIMITNDOSE A LAS GARANTAS DE
 * MERCANTIBILIDAD, ADECUACIN PARA UN PROPSITO EN PARTICULAR Y NO 
 * INFRACCIN DE LOS DERECHOS DE TERCERAS PARTES. EN NINGN MOMENTO EL O LOS 
 * TITULARES DE LOS DERECHOS DE AUTOR Y COPYRIGHT INCLUIDOS EN ESTE AVISO SERN
 * RESPONSABLES POR CUALQUIER RECLAMACIN O POR CUALQUIER DAO ESPECIAL,
 * INDIRECTO O CONSECUENTE, O CUALQUIER DAO QUE RESULTE DE LA PRDIDA DE USO,
 * DATOS O GANANCIAS, YA SEA EN UNA ACCIN DE CONTRATO, NEGLIGENCIA U OTRA 
 * ACCIN TORTUORIA, RESULTANTE DE O EN CONEXIN CON EL USO O DESEMPEO DE
 * ESTE SOFTWARE.
 *
 * Excepto que se incluya en ste aviso, no se debe usar el nombre de ningn 
 * titular de Derechos de autor o Copyright en publicidad o de otra manera 
 * psra promover la venta, uso u otros tratos en este Software sin previa 
 * autorizacin por escrito del titular de Derechos de autor o Copyright.
 * --TERMINA LICENCIA----------------------------------------------------------
 *
 * --BEGIN LICENSE IN US ENGLISH-----------------------------------------------
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, provided that the above
 * copyright and "Derechos reservados" notices and this permission notice  
 * (in spanish and english) appear in all copies of the Software and that both 
 * the above copyright and "Derechos reservados" notices and this permission 
 * notice (in spanish and english) appear in supporting documentation.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
 * OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT AND "DERECHOS DE 
 * AUTOR" HOLDER OR HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR 
 * ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * Except as contained in this notice, the name of a copyright or "Derechos de
 * autor" holder shall not be used in advertising or otherwise to promote the
 * sale, use or other dealings in this Software without prior written 
 * authorization of the copyright or "Derechos de autor" holder.
 * --END LICENSE---------------------------------------------------------------
 */

# Changelog: 

# 2002-01-05 Sandino Araico Snchez - Unique user authentication

if(!defined("__HOPP_UNIQUE_AUTH"))
{
define ("__HOPP_UNIQUE_AUTH",1);
#---------------------------------------------------------------------
include __HOPP_INCLUDE_PATH.'auth/basic-auth.inc';
#---------------------------------------------------------------------

function auth_unique($defid=0)
{
	return auth_basic($defid, 'auth_unique_query');
}

function auth_unique_headers()
{
	return auth_basic_headers();
}

function auth_unique_headers_send()
{
	return auth_basic_headers_send();
}

function auth_unique_retry($defid=0)
{
	return auth_basic_retry($defid, 'auth_unique');
}

function auth_unique_query($user, $pw, $defid=0)
{
	$id=hopp_db_connected($defid);
	$sql="select count(*) from h_auth_unique_user where h_auth_usr_name = '$user' and h_auth_usr_pw = '".md5($pw)."'";
	s_log("sql: $sql");
	return hopp_db_get_single_field_result($id, $sql);
}

function auth_unique_query_user($user, $defid=0)
{
	$id=hopp_db_connected($defid);
	$sql="select count(*) from h_auth_unique_user where h_auth_usr_name = '$user'";
	s_log("sql: $sql");
	return hopp_db_get_single_field_result($id, $sql);
}

function auth_unique_insert_user($user, $pw, $defid=0)
{
	$id=hopp_db_connected($defid);
	$md5pw=md5($pw);
	$sql="insert into h_auth_unique_user (h_auth_usr_name, h_auth_usr_pw) values ('$user','$md5pw')";
	return hopp_db_exec($id, $sql);
}

function auth_unique_insert_user_data($user, $name, $mail, $title='', $phone='', $defid=0)
{
	$user=rawurlencode(str_replace("'","\'",$user));
	$name=rawurlencode(str_replace("'","\'",$name));
	$mail=rawurlencode(str_replace("'","\'",$mail));
	$title=rawurlencode(str_replace("'","\'",$title));
	$title=hopp_db_get_null_value($title);
	$phone=rawurlencode(str_replace("'","\'",$phone));
	$phone=hopp_db_get_null_value($phone);
	
	$id=hopp_db_connected($defid);
	$sql="insert into h_auth_user_data (h_auth_user_data_user,h_auth_user_data_name,h_auth_user_data_mail,h_auth_user_data_title,h_auth_user_data_phone) values ('$user','$name','$mail',$title,$phone)";
	return hopp_db_exec($id, $sql);
}


#---------------------------------------------------------------------
} //__HOPP_UNIQUE_AUTH

?>
