<?
# Module: Template
# template-basic.inc - Basic template functions
# Derechos Reservados (c) 2000-2002 Sandino Araico Snchez
# Derechos Reservados (c) 2002 Presidencia de la Repblica
# Copyright (c) 2000-2002 Sandino Araico Snchez All rights reserved

/*
 * --COMIENZA LICENCIA EN ESPAOL MEXICANO-------------------------------------
 * Por ste medio se otroga permiso, libre de cargo, a cualquier persona que
 * obtenga una copia de este software y archivos de documentacin asociados
 * (el "Software"), a utilizar el Software sin restriccin, incluyendo sin 
 * limitacin los derechos de usar, copiar, modificar, unir, publicar, 
 * distribuir y/o vender copias de el Software, y permitir lo mismo a personas 
 * a quienes les sea entregado el software, siempre y cuando los avisos de 
 * Derechos reservados y Copyright que aparecen arriba y ste permiso (en 
 * espaol y en ingls) aparezcan en todas las copias de el Software y que 
 * tanto los avisos de Derechos reservados y Copyright que aparecen arriba como
 * ste permiso (en espaol y en ingls) aparezcan en la documentacin de
 * soporte.
 *
 * ESTE SOFTWARE SE PROVEE "TAL CUAL", SIN NINGUNA GARANTA DE NINGN TIPO,
 * EXPRESA O IMPLCITA, INCLUYENDO PERO NO LIMITNDOSE A LAS GARANTAS DE
 * MERCANTIBILIDAD, ADECUACIN PARA UN PROPSITO EN PARTICULAR Y NO 
 * INFRACCIN DE LOS DERECHOS DE TERCERAS PARTES. EN NINGN MOMENTO EL O LOS 
 * TITULARES DE LOS DERECHOS DE AUTOR Y COPYRIGHT INCLUIDOS EN ESTE AVISO SERN
 * RESPONSABLES POR CUALQUIER RECLAMACIN O POR CUALQUIER DAO ESPECIAL,
 * INDIRECTO O CONSECUENTE, O CUALQUIER DAO QUE RESULTE DE LA PRDIDA DE USO,
 * DATOS O GANANCIAS, YA SEA EN UNA ACCIN DE CONTRATO, NEGLIGENCIA U OTRA 
 * ACCIN TORTUORIA, RESULTANTE DE O EN CONEXIN CON EL USO O DESEMPEO DE
 * ESTE SOFTWARE.
 *
 * Excepto que se incluya en ste aviso, no se debe usar el nombre de ningn 
 * titular de Derechos de autor o Copyright en publicidad o de otra manera 
 * psra promover la venta, uso u otros tratos en este Software sin previa 
 * autorizacin por escrito del titular de Derechos de autor o Copyright.
 * --TERMINA LICENCIA----------------------------------------------------------
 *
 * --BEGIN LICENSE IN US ENGLISH-----------------------------------------------
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, provided that the above
 * copyright and "Derechos reservados" notices and this permission notice  
 * (in spanish and english) appear in all copies of the Software and that both 
 * the above copyright and "Derechos reservados" notices and this permission 
 * notice (in spanish and english) appear in supporting documentation.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
 * OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT AND "DERECHOS DE 
 * AUTOR" HOLDER OR HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR 
 * ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * Except as contained in this notice, the name of a copyright or "Derechos de
 * autor" holder shall not be used in advertising or otherwise to promote the
 * sale, use or other dealings in this Software without prior written 
 * authorization of the copyright or "Derechos de autor" holder.
 * --END LICENSE---------------------------------------------------------------
 */
 
# Changelog: 
# 2000-10-13 Sandino Araico Snchez - Basic template functionality
# 2001-09-18 Sandino Araico Sanchez -  h_template_get_parsed_file() 
# 2001-10-02 Sandino Araico Sanchez -  h_template_get_file()
# 2001-11-09 Sandino Araico Sanchez - Cambio de prioridad de las extensiones de los templates
# 2002-03-27 Sandino Araico Sanchez - Some optimization on basic_template_container_probe_name()

if(!defined("__HOPP_TEMPLATE_BASIC"))
{
define ("__HOPP_TEMPLATE_BASIC",1);
#---------------------------------------------------------------------
include __HOPP_INCLUDE_PATH."s.inc";
#---------------------------------------------------------------------
function h_template_get_file($template_file, $probe=1, $persist=0)
{
	if($persist)
	{
		s_log("Looking for persistent template file $template_file",0,0,3);
		$file=h_template_get_file_from_memory($template_file);
		if(!empty($file))
			return $file;
	}
	
	/* This language part should be removed.
	 * Instead, a directory-based language container should be created
	 */
	if($probe)
	{
		if(defined("__HOPP_TEMPLATE_DEF_LANG__"))
			$template_file.=".".__HOPP_TEMPLATE_DEF_LANG__;
	}		
	s_log("Trying to include template from $template_file",0,0,3);
	// If the template does not exist we should look for it
	if(file_exists($template_file))
	{
		s_log("Including template from $template_file",0,0,3);
		$file=fopen($template_file, "r");
		$file_content=fread($file,1048576); // Read up to 1M
		fclose($file);
	}
	else
	{
		if($probe)
		{
			$probed_name=basic_template_container_probe_name($template_file);
			$file_content=h_template_get_file($probed_name, 0, $persist);
			
		}
	}	
	if(empty($file_content))
		return;
	if($persist)
		h_template_put_file_into_memory($template_file, $file_content);
	return $file_content;
}

function h_template_get_parsed_file($template_file, $array, $probe=1, $persist=0)
{
	if(empty($template_file))
		return;


	$file=h_template_get_file($template_file, $probe, $persist);

	if(is_array($array))
	{
		foreach($array as $key => $value)
		{
			s_log("Replacing $key with $value",0,0,3);
			$file=str_replace($key, $value, $file);
		}
	}
	return $file;
}

function h_template_get_file_from_memory($template_file)
{
	global $__HOPP_TEMPLATE_MEMORY_CACHE__;
	if(is_array($__HOPP_TEMPLATE_MEMORY_CACHE__))
	{
		s_log("Looking for file $template_file in memory",0,0,3);
		if(!empty($__HOPP_TEMPLATE_MEMORY_CACHE__[$template_file]))
		{
			s_log("File $template_file found in memory",0,0,3);
			return $__HOPP_TEMPLATE_MEMORY_CACHE__[$template_file];
		}	
	}
}

function h_template_put_file_into_memory($template_file, $file)
{
	s_log("Storing persistent template file $template_file",0,0,3);
	global $__HOPP_TEMPLATE_MEMORY_CACHE__;
	$__HOPP_TEMPLATE_MEMORY_CACHE__[$template_file]=$file;
}

function basic_template_container_hardcoded($template, $theme="", $subtheme="")
{
	return basic_template_container_general(0,0, $template, "H", 0, $theme, $subtheme);
}

function basic_template_container_with_variables($template, $array, $theme="", $subtheme="")
{
	return basic_template_container_general(0,0, $template, "V", $array, $theme, $subtheme);
}

/* 2000-10-17 Sandino Araico Snchez
 * This function is ready to expand variables contained in the array $data
 * in the inclusion of the template.
 * It is possible to expand a functon but I don't want to mess with function names.
 * Perhaps a variable-expand to function-expand template translator is possible
 * but it's not the purpose of this function and should be done in a separate one.
 */
function basic_template_container_general($id, $use_id, $template_file, $expand, $data, $theme, $subtheme, $probe=1)
{
	if(empty($template_file))
		return;
	s_log("Trying to include template from $template_file",0,0,3);
	// If the template does not exist we should look for it
	if(!file_exists($template_file))
		return ($probe?basic_template_container_general($id, $use_id, basic_template_container_probe_name($template_file, $theme, $subtheme), $expand, $data, $theme, $subtheme,0):"");
	s_log("Including template from $template_file",0,0,3);
	switch($expand)
	{
	case "F":
	case "V":
		/* We are using a macro here
		 * Care should be taken that macros are executable on include
		 * Notice that we use include instead of require 
		 */ 
		$__HOPP_VARIABLES_ARRAY__=$data;
		include "include/MACRO/extract_variables_from_array.inc";	
	default:
		return $template_file;
	}
}

function basic_template_container_probe_name($name, $theme="", $subtheme="", $recurse=1)
{
	s_log("probing $name, theme: $theme, subtheme: $subtheme, recurse: $recurse",0,0,3);
	if(empty($name))
		return;
	if(file_exists($name))
		return $name;
	if($theme)
	{
		if($subtheme)
		{
			$i=basic_template_container_probe_name("$theme/$subtheme/$name","","",$recurse);
			if($i)
				return $i;
			$i=basic_template_container_probe_name("$theme/$name_$subtheme","","",$recurse);	
			if($i)
				return $i;
			$i=basic_template_container_probe_name("$theme/$name.$subtheme","","",$recurse);	
			if($i)	
				return $i;
		}		
		$i=basic_template_container_probe_name("$theme/$name","","",$recurse);
		if($i)	
			return $i;
	}		
	if(!strstr($name, __HOPP_TEMPLATE_DIR__))
	{
		$i=basic_template_container_probe_name(__HOPP_TEMPLATE_DIR__."$name","","",$recurse);
		if($i)	
			return $i;
	}	
	if(!ereg("(\.php$)|(\.inc$)|(\.html$)", $name))	
	{
		$i=basic_template_container_probe_name("$name.html","","",$recurse);
		if($i)	
			return $i;
		$i=basic_template_container_probe_name("$name.inc","","",$recurse);
		if($i)	
			return $i;
		$i=basic_template_container_probe_name("$name.php","","",$recurse);
		if($i)	
			return $i;
	}
	
	if($recurse)
	{
		global $__HOPP_THEME__;
		if($__HOPP_THEME__)
		{
			$i=basic_template_container_probe_name($name, $__HOPP_THEME__, $subtheme, 0);
			if($i)	
				return $i;
		}	
		// FIXME - "default" seems not to be working as expected.....
		/*$i=basic_template_container_probe_name($name, "default", $subtheme, 0);
		if($i)	
			return $i;*/
	}
	if(!defined('__HOPP_TEMPLATE_DIR__')&&!ereg("^hopp/template/", $name))
	{
		if(!ereg("^template/", $name))
		{
			$i=basic_template_container_probe_name("template/$name","","",$recurse);
			if($i)	
				return $i;
		}
		else
		{
			$i=basic_template_container_probe_name("hopp/$name","","",$recurse);
			if($i)	
				return $i;
		}
	}
	s_log("probing $name unsuccessful",0,0,3);
}
#---------------------------------------------------------------------
} //__HOPP_TEMPLATE_BASIC
?>
